/*
 *	ShapeAction.h
 *
 *	Robert Dierkes,  April 26, 1993
 */

#include "graphics types.h"

typedef struct
{
		gxShape			*pShapes;
		gxShape			boxes;

		gxShapePart		partsHit;
		fixed			tolerance;

		boolean			showControlPoints,
						showLocalBounds;

		boolean		   testNothing;
		boolean			testBounds;
		boolean			testGeometry;
		boolean			testPen;
		boolean			testCornerPoint;
		boolean			testControlPoint;
		boolean			testEdge;
		boolean			testJoin;		/* also testGlyphBounds */
		boolean			testStartCap;	/* also testGlyphFirst  */
		boolean			testEndCap;		/* also testGlyphLast   */
		boolean			testDash;		/* also testSideBearing */
		boolean			testPattern;
		boolean		   testAnything;

		ControlHandle  hNothing;
		ControlHandle	hBounds;
		ControlHandle	hGeometry;
		ControlHandle	hPen;
		ControlHandle	hCornerPoint;
		ControlHandle	hControlPoint;
		ControlHandle	hEdge;
		ControlHandle	hJoin;			/* also hGlyphBoundsPart */
		ControlHandle	hStartCap;		/* also hGlyphFirstPart  */
		ControlHandle	hEndCap;		/* also hGlyphLastPart   */
		ControlHandle	hDash;			/* also hSideBearingPart */
		ControlHandle	hPattern;
		ControlHandle  hAnything;

} GlobalStructure;

#define	notOnAnyShape	-1

void ShowControlPoints (gxShape *p1stShape, long shapeCount);
void UpdateHitTestWindow (WindowPtr pWindow);
void UpdateShapePartInfo (Point *pQDWhere, GlobalStructure *pG);
