/*
	interfaces for a simple, one-window graphics shell
	
	1990 - 1994  Apple Computer, Inc.
	All rights reserved.
*/

#include <Desk.h>
#include <Dialogs.h>
#include <Events.h>
#include <Fonts.h>
#include <Windows.h>
#include <Memory.h>
#include <ToolUtils.h>
#include <Menus.h>
#include <Resources.h>
#include <Quickdraw.h>
#include <GestaltEqu.h>
#include <CodeFragments.h>

#include "graphics toolbox.h"
#include "graphics routines.h"
#include "graphics libraries.h"
#include "graphics debugging.h"
#include "graphics macintosh.h"
#include "font library.h"



/**\
|**| ---------------------------------------------------------------------
|**| EXTERN GLOBALS
|**| ---------------------------------------------------------------------
\**/
/* these things are kept up-to-date by the shell and may be accessed at any time by the application. */
extern WindowPtr 		gWindow;
extern gxShape 			gWindowBoundsShape;

/* the following are expected to be initialized by the application */
extern Boolean			gDebugging;
extern Boolean			gGiveMeValidation;
extern long				gGraphicsHeapSize;


/**\
|**| ---------------------------------------------------------------------
|**| PROTOTYPES
|**| ---------------------------------------------------------------------
\**/

// QuickDraw GX shell.c:

void	main					(void);
void 	InitToolbox				(void);
void	CheckQuickDrawGX		(void);
void	EventLoop				(void);
void	MyDoEvent				(EventRecord *event);
void	DoMouseDown				(EventRecord *event);
void	SetUpGXDebuggingWorld	(Boolean GXDebuggingInstalled);

/* the following functions are supplied by the application using the shell and are called at the appropriate time. */
void DoInitialization		(WindowPtr);
void DoDraw					(WindowPtr);
void DoDispose				(WindowPtr);
void DoClick				(gxPoint, WindowPtr);
void DoIdle					(WindowPtr);


/**\
|**| ---------------------------------------------------------------------
|**| ENUMS
|**| ---------------------------------------------------------------------
\**/
enum dlogIDs {rNoQuickDrawGXID=129};



