#
#   File:       viewPort Mania.mpwfat.make
#
#   Target:     viewPort Mania.mpwfat 
#
#   Why:  This makefile creates a "FAT" version of the QuickDraw GX sample shell app
#	        Since we built a "FAT" version of this app, it will run on a 68k or PowerPC Mac running
#         QuickDraw GX v1.0 or newer.
#
#   Sources:    "{GXGRAPHICSLIBS}color library.c"
#               "{GXGRAPHICSLIBS}font library.c"
#               "{GXGRAPHICSLIBS}graphics debug library.c"
#               "{GXGRAPHICSLIBS}shape library.c"
#               "{GXGRAPHICSLIBS}transform library.c"
#               "graphics shell.r"
#               "graphics shell.c"
#               "put your code here.c"
#
#   Created:    Wednesday, December 22, 1993 05:09:44 PM
#

ThisMakeFile		=	viewPort Mania.mpwfat.make

GXINTERFACES 	= {CIncludes}
SOURCE				=	:
OBJ68K				=	:Obj68K:
OBJPPC				=	:ObjPPC:
GXGRAPHICSLIBS 			= 	QuickDraw GX SDK:Programming Stuff:QuickDraw GX Libraries:Graphics Libraries:
GXGRAPHICSLIBS68K 	= 	{OBJ68K}
GXGRAPHICSLIBSPPC 	= 	{ObjPPC}

68KOBJECTS 		=	"{GXGRAPHICSLIBS68K}color library.c.o" 
					"{GXGRAPHICSLIBS68K}font library.c.o" 
					"{GXGRAPHICSLIBS68K}graphics debug library.c.o" 
					"{GXGRAPHICSLIBS68K}shape library.c.o"			
					"{GXGRAPHICSLIBS68K}transform library.c.o" 
					"{OBJ68K}graphics shell.c.o" 
					"{OBJ68K}viewPort Mania.c.o" 

POWERPCOBJECTS 	= 	"{GXGRAPHICSLIBSPPC}color library.o"
					"{GXGRAPHICSLIBSPPC}font library.o" 
					"{GXGRAPHICSLIBSPPC}graphics debug library.o" 
					"{GXGRAPHICSLIBSPPC}shape library.o"			
					"{GXGRAPHICSLIBSPPC}transform library.o" 
					"{OBJPPC}graphics shell.o" 
					"{OBJPPC}viewPort Mania.o" 

CSYMOPTIONS			= -sym on

#
# MakePEF allows us to "weak" link to QuickDrawGXLib so our PowerPC code can run if the library
# isn't present.  It's up to the app to check before we call any of the GX functions, though.  
# We specify weaking linking by appending a ~ at the end of the -l option to MakePEF (see below).
# When we do that, though MakePEF will whine about the library being weak linked, but various
# entry points not being weak linked.  We can get MakePEF to be quiet by using a -w option for each
# entry point.  That list is below.
#
WEAKENTRYPOINTS		=  -w QuickDrawGXLib:GXGetFont 
					-w QuickDrawGXLib:GXGetDefaultFont 
					-w QuickDrawGXLib:GXFindFonts 
					-w QuickDrawGXLib:GXFindFontName 
					-w QuickDrawGXLib:GXCountFontVariations 
					-w QuickDrawGXLib:GXFindFontVariation 
					-w QuickDrawGXLib:GXFindFontDescriptor 
					-w QuickDrawGXLib:GXSetValidation 
					-w QuickDrawGXLib:GXGetValidationError 
					-w QuickDrawGXLib:GXNewGraphicsClient 
					-w QuickDrawGXLib:GXDisposeGraphicsClient 
					-w QuickDrawGXLib:GXEnterGraphics 
					-w QuickDrawGXLib:GXExitGraphics 
					-w QuickDrawGXLib:GXGetGraphicsError 
					-w QuickDrawGXLib:GXPostGraphicsError 
					-w QuickDrawGXLib:GXGetUserGraphicsError 
					-w QuickDrawGXLib:GXGetUserGraphicsNotice 
					-w QuickDrawGXLib:GXGetUserGraphicsWarning 
					-w QuickDrawGXLib:GXSetUserGraphicsError 
					-w QuickDrawGXLib:GXSetUserGraphicsNotice 
					-w QuickDrawGXLib:GXSetUserGraphicsWarning 
					-w QuickDrawGXLib:GXIgnoreGraphicsNotice 
					-w QuickDrawGXLib:GXPopGraphicsNotice 
					-w QuickDrawGXLib:GXNewRectangle 
					-w QuickDrawGXLib:GXNewText 
					-w QuickDrawGXLib:GXGetBitmap 
					-w QuickDrawGXLib:GXGetPicture 
					-w QuickDrawGXLib:GXSetBitmap 
					-w QuickDrawGXLib:GXSetText 
					-w QuickDrawGXLib:GXNewColorSet 
					-w QuickDrawGXLib:GXNewTransform 
					-w QuickDrawGXLib:GXNewViewGroup 
					-w QuickDrawGXLib:GXNewViewPort 
					-w QuickDrawGXLib:GXDisposeColorSet 
					-w QuickDrawGXLib:GXDisposeShape 
					-w QuickDrawGXLib:GXDisposeStyle 
					-w QuickDrawGXLib:GXDisposeTransform 
					-w QuickDrawGXLib:GXCloneColorProfile 
					-w QuickDrawGXLib:GXCloneColorSet 
					-w QuickDrawGXLib:GXCloneTransform 
					-w QuickDrawGXLib:GXCopyToStyle 
					-w QuickDrawGXLib:GXCopyToTransform 
					-w QuickDrawGXLib:GXCopyToViewDevice 
					-w QuickDrawGXLib:GXCopyToViewPort 
					-w QuickDrawGXLib:GXResetTransform 
					-w QuickDrawGXLib:GXDrawShape 
					-w QuickDrawGXLib:GXGetDefaultShape 
					-w QuickDrawGXLib:GXGetShapeBounds 
					-w QuickDrawGXLib:GXGetShapeTransform 
					-w QuickDrawGXLib:GXGetShapeType 
					-w QuickDrawGXLib:GXSetShapeFill 
					-w QuickDrawGXLib:GXSetShapeTransform 
					-w QuickDrawGXLib:GXGetStyleFont 
					-w QuickDrawGXLib:GXGetStyleFontVariations 
					-w QuickDrawGXLib:GXSetShapeFont 
					-w QuickDrawGXLib:GXSetShapePen 
					-w QuickDrawGXLib:GXSetShapeTextSize 
					-w QuickDrawGXLib:GXSetStyleFace 
					-w QuickDrawGXLib:GXSetStyleFont 
					-w QuickDrawGXLib:GXSetStyleFontVariations 
					-w QuickDrawGXLib:GXGetShapeColor 
					-w QuickDrawGXLib:GXGetInkColor 
					-w QuickDrawGXLib:GXSetShapeColor 
					-w QuickDrawGXLib:GXSetInkColor 
					-w QuickDrawGXLib:GXGetTransformMapping 
					-w QuickDrawGXLib:GXGetTransformViewPorts 
					-w QuickDrawGXLib:GXSetShapeViewPorts 
					-w QuickDrawGXLib:GXSetTransformMapping 
					-w QuickDrawGXLib:GXSetTransformViewPorts 
					-w QuickDrawGXLib:GXGetViewDeviceBitmap 
					-w QuickDrawGXLib:GXSetViewDeviceBitmap 
					-w QuickDrawGXLib:GXSetViewDeviceViewGroup 
					-w QuickDrawGXLib:GXGetViewPortClip 
					-w QuickDrawGXLib:GXGetViewPortMapping 
					-w QuickDrawGXLib:GXGetViewPortParent 
					-w QuickDrawGXLib:GXSetViewPortClip 
					-w QuickDrawGXLib:GXSetViewPortDither 
					-w QuickDrawGXLib:GXSetViewPortHalftone 
					-w QuickDrawGXLib:GXSetViewPortMapping 
					-w QuickDrawGXLib:GXSetViewPortParent 
					-w QuickDrawGXLib:GXSetViewPortViewGroup 
					-w QuickDrawGXLib:GXSetShapeAttributes 
					-w QuickDrawGXLib:GXSetShapeStyleAttributes 
					-w QuickDrawGXLib:GXSetViewPortAttributes 
					-w QuickDrawGXLib:GXGetTransformOwners 
					-w QuickDrawGXLib:GXGetViewGroupViewDevices 
					-w QuickDrawGXLib:GXGetViewGroupViewPorts 
					-w QuickDrawGXLib:GXConvertColor 
					-w QuickDrawGXLib:GXGetPictureParts 
					-w QuickDrawGXLib:GXSetPictureParts 
					-w QuickDrawGXLib:GXMoveShapeTo 
					-w QuickDrawGXLib:GXRotateShape 
					-w QuickDrawGXLib:GXScaleTransform 
					-w QuickDrawGXLib:GXSkewTransform 
					-w QuickDrawGXLib:GXNewWindowViewPort 
					-w QuickDrawGXLib:GXGetWindowViewPort 
					-w QuickDrawGXLib:GXConvertQDPoint 
					-w QuickDrawGXLib:CopyToMapping 
					-w QuickDrawGXLib:MapMapping 
					-w QuickDrawGXLib:ScaleMapping 
					-w QuickDrawGXLib:ResetMapping 
					-w QuickDrawGXLib:FixedMultiply


#
#	You need to define debugging to enable all of the GX warnings available only in the 
#	debugging version of the QuickDraw GX debugging init.
#
COPTIONS 				= -d debugging -i "{GXINTERFACES}" {CSYMOPTIONS}

PPCSYMOPTIONS		= -sym on

PPCCOPTIONS 		= -d debugging -i "{GXINTERFACES}" -w conformance -appleext on {PPCSYMOPTIONS}

#------------------------------------------------------------------------------
# These are modified default build rules.  This is so we can automatically 
# build for both 68K and PowerPC.
#------------------------------------------------------------------------------
"{OBJ68K}"					"{SOURCE}"

"{GXGRAPHICSLIBS68K}"		"{GXGRAPHICSLIBS}"

.c.o						.c
	{C} {COptions} {DepDir}{Default}.c -o {TargDir}{Default}.c.o

"{OBJPPC}"					"{SOURCE}"

"{GXGRAPHICSLIBSPPC}"		"{GXGRAPHICSLIBS}"

.o							.c
	PPCC {PPCCOptions} {DepDir}{Default}.c -o {TargDir}{Default}.o

#------------------------------------------------------------------------------


"viewPort Mania.mpwfat"   "{ThisMakeFile}" 'graphics shell.r'
	Rez 'graphics shell.r' -append -o "viewPort Mania.mpwfat"

"viewPort Mania.mpwfat"  "{ThisMakeFile}"  {POWERPCOBJECTS}
	PPCLink  {PPCSYMOPTIONS} 
		{POWERPCOBJECTS} 
		"{PPCLibraries}"InterfaceLib.xcoff 
		"{PPCLibraries}"QuickDrawGXLib.xcoff 
		"{PPCLibraries}"MathLib.xcoff 
		"{PPCLibraries}"StdCLib.xcoff 
		"{PPCLibraries}"StdCRuntime.o 
		"{PPCLibraries}"PPCCRuntime.o 
		-main __start 
		-o "viewPort Mania.mpwfat.xcoff"
	makePEF "viewPort Mania.mpwfat.xcoff" -o "viewPort Mania.mpwfat" 
		-l InterfaceLib.xcoff=InterfaceLib 
  	-l QuickDrawGXLib.xcoff=QuickDrawGXLib~ 
		-l MathLib.xcoff=MathLib 
		-l StdCLib.xcoff=StdCLib 
		{WEAKENTRYPOINTS} 
		-ft APPL -fc '????'
	MakeSYM -i "{GXGRAPHICSLIBS}" "viewPort Mania.mpwfat.xcoff" -o "viewPort Mania.mpwfat.xSYM"

"viewPort Mania.mpwfat"  "{ThisMakeFile}"  {68KOBJECTS}
	Link -t APPL -c '????' {CSYMOPTIONS} -mf 
		{68KOBJECTS} 
 		"{Libraries}"Runtime.o 
 		"{Libraries}"Interface.o 
		-o "viewPort Mania.mpwfat"
